package com.zzys.lightting.file;

import com.zzys.lightting.base.rest.BaseController;
import com.zzys.lightting.utils.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.io.FileUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;

/**
 * @Author: zzf
 * @Date: 2024/5/27:17:35
 * @Description:
 */
@Api(tags = "文件")
@RestController
@RequestMapping("/file")
public class FileController extends BaseController {
    @PostMapping("/customUpload")
    @ApiOperation(value = "文件上传",notes = "file:源文件；flag：0头像源文件；1音乐源文件")
    public Result customUpload(MultipartFile file,int flag) throws Exception {
        //文件保存
        String fileName = "";
        String filedir = "./light-ting/";
        //0 头像  ；1 音乐
        if(flag==0){
            filedir = filedir+"/avatar/";
        }else if (flag == 1){
            filedir = filedir+"/musics/";
        }else {
            return fail("文件类型有误");
        }
        if (file == null) {
            throw new Exception("文件为空");
        } else {
            String suffix = file.getOriginalFilename();
            if (!file.isEmpty()) {
                fileName = suffix;
                try {
                    File temp = new File(filedir);
                    if (!temp.exists()) {
                        temp.mkdirs();
                    }
                    System.out.println("filedir---" + filedir);
                    System.out.println("fileName--" + fileName);
                    assert fileName != null;
                    File fileLocal = new File(filedir, fileName);
                    FileUtils.copyInputStreamToFile(file.getInputStream(), fileLocal);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
        return success(filedir+fileName);
    }
}
