package com.zzys.lightting.music.dao.model;

import com.zzys.lightting.base.model.BaseEntity;
import lombok.*;
import org.hibernate.Hibernate;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Objects;

/**
 * @Author: zzf
 * @Date: 2024/5/23:11:42
 * @Description:
 */
@Entity
@ToString
@RequiredArgsConstructor
@Getter
@Setter
@AllArgsConstructor
@Table(name = "lt_music_info")
@org.hibernate.annotations.Table(appliesTo = "lt_music_info", comment = "音乐表")
@DynamicUpdate
public class MusicInfo extends BaseEntity {
    @Column(name = "name",columnDefinition = "varchar(50) not null comment '名称'")
    private String name;

    @Column(name = "author",columnDefinition = "varchar(50) comment '作者'")
    private String author;

    @Column(name = "source_file",columnDefinition = "varchar(100) comment '源文件位置'")
    private String sourceFile;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o)) return false;
        MusicInfo musicInfo = (MusicInfo) o;
        return getId() != null && Objects.equals(getId(), musicInfo.getId());
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }
}
