package com.zzys.lightting.music.dao.model;

import com.zzys.lightting.base.model.BaseEntity;
import lombok.*;
import org.hibernate.Hibernate;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Objects;

/**
 * @Author: zzf
 * @Date: 2024/5/23:09:33
 * @Description:
 */
@Entity
@ToString
@RequiredArgsConstructor
@Getter
@Setter
@AllArgsConstructor
@Table(name = "lt_type_info")
@org.hibernate.annotations.Table(appliesTo = "lt_type_info", comment = "音乐分类表")
@DynamicUpdate
public class TypeInfo extends BaseEntity {

    @Column(name = "name",columnDefinition = "varchar(50) not null comment '名称'")
    private String name;

    @Column(name = "sort",columnDefinition = "int not null comment '序号'")
    private int sort;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o)) return false;
        TypeInfo typeInfo = (TypeInfo) o;
        return getId() != null && Objects.equals(getId(), typeInfo.getId());
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }
}
