package com.zzys.lightting.music.rest;

import com.alibaba.fastjson.JSONObject;
import com.zzys.lightting.base.rest.BaseController;
import com.zzys.lightting.music.dao.model.TypeInfo;
import com.zzys.lightting.music.service.TypeService;
import com.zzys.lightting.utils.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @Author:zzf
 * @Date:2024/5/23:09:40
 * @Description:
 */
@Slf4j
@RestController
@RequestMapping("/type")
@Api(tags = "音乐分类管理")
public class TypeController extends BaseController {

    @Autowired
    private TypeService typeService;

    @ApiOperation(value = "保存：新增/更新",notes = "name:名称;order:序号")
    @PostMapping("/save")
    public Result save(@RequestBody String json){
        JSONObject.parseObject(json).toJavaObject(TypeInfo.class);
        return success();
    }

    @ApiOperation("查询")
    @GetMapping("/find")
    public Result find(){
        return success(this.typeService.findAll());
    }

    @ApiOperation("删除")
    @DeleteMapping("/delete/{id}")
    public Result delete(@PathVariable String id){
        this.typeService.deleteById(id);
        return success();
    }
}
