package com.zzys.lightting.music.service.impl;

import com.zzys.lightting.music.dao.model.MusicInfo;
import com.zzys.lightting.music.dao.repository.MusicRepository;
import com.zzys.lightting.music.service.MusicService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;
import java.util.ArrayList;
import java.util.List;

/**
 * @Author:zzf
 * @Date:2024/5/23:14:42
 * @Description:
 */
@Service
public class MusicServiceImpl implements MusicService {
    @Autowired
    private MusicRepository repository;
    @Override
    public MusicInfo save(MusicInfo music) {
        return this.repository.save(music);
    }

    @Override
    public void deleteById(String id) {
        this.repository.deleteById(id);
    }

    @Override
    public List<MusicInfo> findAll() {
        return this.repository.findAll();
    }

    @Override
    public Page<MusicInfo> findByIds(List<String> musicIdList,int pageNum,int pageSize) {
        if(pageNum == 0){
            pageNum =1;
        }
        if(pageSize == 0){
            pageSize = 10;
        }
        Specification<MusicInfo> specification = (root, query, criteriaBuilder) -> {
          List<Predicate> predicateList = new ArrayList<>();
          predicateList.add(root.get("musicId").in(predicateList));
          query.where(criteriaBuilder.and(predicateList.toArray(new Predicate[0])));
          query.orderBy(criteriaBuilder.asc(root.get("order")));
          return query.getRestriction();
        };
        return this.repository.findAll(specification, PageRequest.of(pageNum-1,pageSize));
    }
}
