package com.zzys.lightting.template.dao.model;

import com.zzys.lightting.base.model.BaseEntity;
import lombok.*;
import org.hibernate.Hibernate;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Objects;

/**
 * @Author: zzf
 * @Date: 2024/5/23:16:08
 * @Description:
 */
@Entity
@ToString
@RequiredArgsConstructor
@Getter
@Setter
@AllArgsConstructor
@Table(name = "lt_template_info")
@org.hibernate.annotations.Table(appliesTo = "lt_template_info", comment = "用户音乐模板表")
@DynamicUpdate
public class TemplateInfo extends BaseEntity {
    @Column(name = "user_id",columnDefinition = "varchar(50) not null comment '用户id'")
    private String userId;

    @Column(name = "name",columnDefinition = "varchar(50) not null comment '模板名称'")
    private String name;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o)) return false;
        TemplateInfo that = (TemplateInfo) o;
        return getId() != null && Objects.equals(getId(), that.getId());
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }
}
