package com.zzys.lightting.template.rest;

import com.alibaba.fastjson.JSONObject;
import com.zzys.lightting.base.rest.BaseController;
import com.zzys.lightting.template.dao.model.TemplateInfo;
import com.zzys.lightting.template.service.TemplateMusicService;
import com.zzys.lightting.template.service.TemplateService;
import com.zzys.lightting.utils.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @Author:zzf
 * @Date:2024/5/23:16:38
 * @Description:
 */
@Slf4j
@RestController
@RequestMapping("/template")
@Api(tags = "模板管理")
public class TemplateController extends BaseController {

    @Autowired
    private TemplateService service;
    @Autowired
    private TemplateMusicService templateMusicService;
    @PostMapping("/save")
    @ApiOperation(value = "保存",notes = "name:模板名称；userId：用户id")
    public Result save(@RequestBody String json){
        TemplateInfo templateInfo = JSONObject.parseObject(json).toJavaObject(TemplateInfo.class);
        this.service.save(templateInfo);
        return success();
    }

    @DeleteMapping("/delete/{id}")
    @ApiOperation("删除-id")
    public Result delete(@PathVariable String id){
        templateMusicService.deleteByTemplateId(id);
        this.service.deleteById(id);
        return success();
    }

    @GetMapping("/find/{userId}")
    @ApiOperation("查询-userId")
    public Result findByUserId(@PathVariable String userId){
        List<TemplateInfo> templateInfoList = this.service.findByUserId(userId);
        return success(templateInfoList);
    }



}
