package com.zzys.lightting.user.dao.model;

import com.zzys.lightting.base.model.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;
import org.hibernate.Hibernate;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Objects;

/**
 * @Author: zzf
 * @Date: 2024/5/22:11:07
 * @Description:
 */
@Entity
@ToString
@RequiredArgsConstructor
@Getter
@Setter
@AllArgsConstructor
@Table(name = "lt_user_info")
@org.hibernate.annotations.Table(appliesTo = "lt_user_info", comment = "用户信息表")
@DynamicUpdate
public class UserInfo extends BaseEntity {

    @ApiModelProperty("手机号")
    @Column(name = "phone",columnDefinition = "varchar(12) NOT NULL COMMENT '手机号'")
    private String phone;

    @Column(name = "name",columnDefinition = "varchar(10) NULL COMMENT '昵称'")
    private String name;


    @Column(name = "open_id",columnDefinition = " varchar(50) NULL COMMENT '微信openId'")
    private String openId;

    @Column(name = "type",columnDefinition = " varchar(10) NULL COMMENT '用户类型 0-普通用户 1-管理端用户'")
    private String type;


    @Column(name = "password",columnDefinition = "varchar(32) COMMENT '密码，管理端用户'")
    private String password;

    @Transient
    private String photoPath;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o)) return false;
        UserInfo userInfo = (UserInfo) o;
        return getId() != null && Objects.equals(getId(), userInfo.getId());
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }
}
