package com.zzys.lightting.user.dao.model;

import com.zzys.lightting.base.model.BaseEntity;
import lombok.*;
import org.hibernate.Hibernate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Objects;

/**
 * @Description: 用户头像关联表
 * @Author: mimang
 * @Date: 2023/4/24
 */
@Entity
@Getter
@Setter
@ToString
@RequiredArgsConstructor
@AllArgsConstructor
@Table(name = "lt_user_photo_info")
@org.hibernate.annotations.Table(appliesTo = "lt_user_photo_info", comment = "用户头像")
public class UserPhotoInfo extends BaseEntity {

    @Column(name = "path", columnDefinition = "varchar(36)   COMMENT '路径'")
    private String path;

    @Column(name = "user_id", columnDefinition = "varchar(36)   COMMENT '用户ID'")
    private String userId;


    @Column(name = "create_time", columnDefinition = "varchar(20)   COMMENT '创建时间'")
    private String createTime;

    @Column(name = "update_time", columnDefinition = "varchar(20)   COMMENT '更新时间'")
    private String updateTime;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o)) return false;
        UserPhotoInfo that = (UserPhotoInfo) o;
        return getId() != null && Objects.equals(getId(), that.getId());
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }
}
