package com.zzys.lightting.user.service.impl;

import com.zzys.lightting.user.dao.model.UserInfo;
import com.zzys.lightting.user.dao.repository.UserRepository;
import com.zzys.lightting.user.service.UserPhotoService;
import com.zzys.lightting.user.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Author:zzf
 * @Date:2024/5/22:11:34
 * @Description:
 */
@Service
public class UserServiceImpl implements UserService {
    @Autowired
    UserRepository userRepository;
    @Autowired
    UserPhotoService userPhotoService;
 

    @Override
    public UserInfo findByOpenId(String openid) {
        return this.userRepository.findByOpenId(openid);
    }

    @Override
    public UserInfo save(UserInfo userInfo) {
        return this.userRepository.save(userInfo);
    }

    @Override
    public UserInfo findById(String userId) {
        return userRepository.findById(userId).orElse(null);
    }

    @Override
    public UserInfo login(String userName, String password) {
        return this.userRepository.findByNameAndPassword(userName,password);
    }
}
